import processing.core.PApplet;
import toxi.geom.*;
import toxi.processing.ToxiclibsSupport;

public class Fan extends BoilerPlate {
	PApplet parent;
	public int seed;
	public float seedNormal;

	public Vec3D startDirection;
	public Vec3D endDirection;
	public Ray3D start;
	public Ray3D end;

	Fan(PApplet p) {
		parent = p;
		setScope("Fan");
	}
	
	public void randomizeControls(){
		float r;
		r = 1.0f;
		startDirection = new Vec3D(getRandom(-r, r), getRandom(-r, r), getRandom(-r, r));
		endDirection = new Vec3D(getRandom(-r, r), getRandom(-r, r), getRandom(-r, r));

		r = 400.0f;
		start = new Ray3D(getRandom(-r, r), getRandom(-r, r), getRandom(-r, r), startDirection);
		end = new Ray3D(getRandom(-r, r), getRandom(-r, r), getRandom(-r, r), endDirection);
		
	}

	public void parse() {
		// tracer("parse");
	}

	public void draw(ToxiclibsSupport gfx) {
		// tracer("draw");
		parent.noFill();
		
		parent.strokeWeight(1);
		parent.stroke(255);
		gfx.line(start,end);

		// -----------------------
		parent.stroke(153,102,51);

		parent.strokeWeight(3);
		gfx.point(start);
		
		parent.strokeWeight(1);
		gfx.ray(start,100.0f);
		
		// -----------------------
		parent.stroke(51, 102,153);

		parent.strokeWeight(3);
		gfx.point(end);

		parent.strokeWeight(1);
		gfx.ray(end,100.0f);
	}

}